﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CV8_1lib
{
    public class Student : IComparable<Student>, IEnumerable<Predmet>, IEnumerator<Hra>, IEnumerable<Hra>
    {
        string jmeno;
        int pocetNeuspesnychPredmetu;
        int pocetUspesnychPredmetu;

        List<Predmet> predmety = new List<Predmet>();
        Hra[] oblibeneHry;

        public Student(string jmeno, int pocetNeuspesnychPredmetu,
        int pocetUspesnychPredmetu, int pocetOblibeneHry)
        {
            this.pocetNeuspesnychPredmetu = pocetNeuspesnychPredmetu;
            this.pocetUspesnychPredmetu = pocetUspesnychPredmetu;
            this.jmeno = jmeno;
            oblibeneHry = new Hra[pocetOblibeneHry];
        }
        #region metody
        public override string ToString()
        {
            return $"{jmeno} U:{pocetUspesnychPredmetu} N:{pocetNeuspesnychPredmetu}";
        }

        public void PridejPredmet(Predmet p)
        {
            predmety.Add(p);
        }


        public void PridejHry()
        {
            oblibeneHry[0] = new Hra("H1");
            oblibeneHry[1] = new Hra("H2");
        }
        #endregion

        #region IComparable
        public int CompareTo(Student other)
        {
            if(this.pocetUspesnychPredmetu > other.pocetUspesnychPredmetu)
            {
                return 1;
            }
            else if(this.pocetUspesnychPredmetu < other.pocetUspesnychPredmetu)
            {
                return -1;
            }
            else
            {
                if (this.pocetNeuspesnychPredmetu > other.pocetNeuspesnychPredmetu)
                {
                    return -1;
                }
                else if (this.pocetNeuspesnychPredmetu < other.pocetNeuspesnychPredmetu)
                {
                    return 1;
                }
                else
                {
                    return 0;
                }
            }
        }
        #endregion

        #region IEnumerator
        public IEnumerator<Predmet> GetEnumerator()
        {
            return predmety.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }
        #endregion

        #region IEnumerable

        int counter = -1;
        public Hra Current
        {
            get
            {
                return oblibeneHry[counter];
            }
        }

        object IEnumerator.Current
        {
            get
            {
                return Current;
            }
        }

        public void Dispose()
        {
            Reset();
        }

        public bool MoveNext()
        {
            counter++;
            return counter < oblibeneHry.Length; 
        }

        public void Reset()
        {
            counter = -1;
        }
        #endregion
    }
}
